var now = new Date();
var flist = new Array();
var llist = new Array();
var rcnt = 0;
var pool = null;
function Download(target)
{
	if (!CheckActive(false))
		return;
	var name = target.split(/\//);
	var oDiv = document.getElementById('dlinfo');
	while (oDiv.firstChild)
		oDiv.removeChild(oDiv.firstChild);
	var oText = document.createTextNode(
		'名前: ' + name[1] + ' サイズ: ' + FormatNumber(name[2]) + 'バイト');
	oDiv.appendChild(oText);
	ShowMessage("ダウンロードの準備をしています。\n"
		+ "しばらくお待ちください...", false);
	var oLink = document.getElementById('dllink');
	oLink.setAttribute('download', name[1]);
	oLink.setAttribute('href', '#');
	oLink.onclick = function () {
		return false;
	}
	var oBtn = document.getElementById('dlbtn');
	oBtn.style.color = '#CCCCCC';
	oBtn.style.cursor = 'default';
	oBtn.onmouseover = null;
	oBtn.onmouseout = null;
	while (oBtn.firstChild)
		oBtn.removeChild(oBtn.firstChild);
	oText = document.createTextNode('開始');
	oBtn.appendChild(oText);
	var oForm = document.getElementById('dlform');
	oForm.captcha.value = '';
	oForm.captcha.disabled = false;
	oForm.ident.value = target;
	oForm.trial.value = 0;
	oForm.sess.value = 0;
	oForm.length.value = name[2];
	oForm.offset.value = 0;
	var oImg = document.getElementById('dlcapimg');
	oImg.setAttribute('src', SolidColor(0xCCCCCC));
	oImg = document.getElementById('dlprogimg1');
	oImg.setAttribute('width', 0);
	oImg = document.getElementById('dlprogimg0');
	oImg.setAttribute('width', 200);
	oDiv = document.getElementById('dlsta');
	while (oDiv.firstChild)
		oDiv.removeChild(oDiv.firstChild);
	OpenDownload();
	var req = new XMLHttpRequest();
	req.open('POST', '/cabinet/', true);
	req.onload = function () {
		RequestCaptcha(req);
	}
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	req.send('rev=5&renew=5');
	SetActive(1);
}
function RestartDownload()
{
	ShowMessage("ダウンロードの準備をしています。\n"
		+ "しばらくお待ちください...", false);
	var oForm = document.getElementById('dlform');
	oForm.captcha.value = '';
	oForm.captcha.disabled = false;
	oForm.offset.value = 0;
	var oImg = document.getElementById('dlcapimg');
	oImg.setAttribute('src', SolidColor(0xCCCCCC));
	oImg = document.getElementById('dlprogimg1');
	oImg.setAttribute('width', 0);
	oImg = document.getElementById('dlprogimg0');
	oImg.setAttribute('width', 200);
	var oDiv = document.getElementById('dlsta');
	while (oDiv.firstChild)
		oDiv.removeChild(oDiv.firstChild);
	var req = new XMLHttpRequest();
	req.open('POST', '/cabinet/', true);
	req.onload = function () {
		RequestCaptcha(req);
	}
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	req.send('rev=5&renew=5');
	SetActive(1);
}
function RequestCaptcha(req)
{
	if (CheckAbort())
		return;
	var mode = 0;
	if (req.status == 200) {
		if (req.responseText.charAt(0) == ' ') {
			var info = req.responseText.substr(1).split(',');
			var oForm = document.getElementById('dlform');
			oForm.sess.value = info[0];
			var oDiv = document.getElementById('dlsta');
			var oText = document.createTextNode('接続元: ' + info[1]);
			oDiv.appendChild(oText);
			var req2 = new XMLHttpRequest();
			req2.open('POST', '/captcha/', true);
			req2.responseType = 'arraybuffer';
			req2.onload = function () {
				ShowCaptcha(req2);
			}
			req2.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			req2.send('sess=' + info[0]);
			mode = 2;
		}
		else
			ShowMessage(req.responseText, true);
	}
	else
		ShowMessage('通信エラーが発生しました。', true);
	SetActive(mode);
}
function ShowCaptcha(req)
{
	if (CheckAbort())
		return;
	if (req.status == 200) {
		var oImg = document.getElementById('dlcapimg');
		var blob = new Blob([req.response], {type:'image/png'});
		oImg.setAttribute('src', window.URL.createObjectURL(blob));
		ShowMessage("下に表示されている文字列を入力して\n"
			+ "[開始] をクリックしてください。", false);
		var oForm = document.getElementById('dlform');
		oForm.captcha.focus();
		oForm.onsubmit = function () {
			StartDownload();
			return false;
		}
		var oLink = document.getElementById('dllink');
		oLink.onclick = function () {
			StartDownload();
			return false;
		}
		var oBtn = document.getElementById('dlbtn');
		oBtn.style.color = '#000000';
		oBtn.style.cursor = 'pointer';
		oBtn.onmouseover = function () {
			this.style.backgroundColor = '#FFFFFF';
		}
		oBtn.onmouseout = function () {
			this.style.backgroundColor = '#EEEEEE';
		}
	}
	else
		ShowMessage('通信エラーが発生しました。', true);
	SetActive(0);
}
function StartDownload()
{
	var oForm = document.getElementById('dlform');
	if (oForm.captcha.value.length != 6) {
		oForm.captcha.focus();
		return;
	}
	oForm.captcha.disabled = true;
	oForm.onsubmit = function () {
		return false;
	}
	var oLink = document.getElementById('dllink');
	oLink.onclick = function () {
		return false;
	}
	var oBtn = document.getElementById('dlbtn');
	oBtn.style.color = '#CCCCCC';
	oBtn.style.cursor = 'default';
	oBtn.onmouseover = null;
	oBtn.onmouseout = null;
	pool = new ArrayBuffer(oForm.length.value);
	var req = new XMLHttpRequest();
	req.open('POST', '/cabinet/', true);
	req.responseType = 'arraybuffer';
	req.onload = function () {
		ReceiveDownload(req);
	}
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	req.send('rev=5'
		+ '&req=' + encodeURIComponent(oForm.ident.value)
		+ '&sess=' + encodeURIComponent(oForm.sess.value)
		+ '&code=' + encodeURIComponent(oForm.captcha.value)
		+ '&offset=' + encodeURIComponent(oForm.offset.value));
	SetActive(3);
}
function ReceiveDownload(req)
{
	if (CheckAbort())
		return;
	var mode = 0;
	if (req.status == 200) {
		var bin = new Uint8Array(req.response);
		var oForm = document.getElementById('dlform');
		if (bin[0] == 0) {
			var dst = new Uint8Array(pool);
			var length = Number(oForm.length.value);
			var offset = Number(oForm.offset.value);
			var size = bin.length - 1;
			if (offset + size <= length) {
				for (var i = 0; i < size; i++)
					dst[offset + i] = bin[i + 1];
				offset += size;
				oForm.offset.value = offset;
				var prog = Math.floor((offset * 200) / length);
				var oImg = document.getElementById('dlprogimg1');
				oImg.setAttribute('width', prog);
				oImg = document.getElementById('dlprogimg0');
				oImg.setAttribute('width', 200 - prog);
				if (offset < length) {
					var req2 = new XMLHttpRequest();
					req2.open('POST', '/cabinet/', true);
					req2.responseType = 'arraybuffer';
					req2.onload = function () {
						ReceiveDownload(req2);
					}
					req2.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
					req2.send('rev=5'
						+ '&req=' + encodeURIComponent(oForm.ident.value)
						+ '&sess=' + encodeURIComponent(oForm.sess.value)
						+ '&code=' + encodeURIComponent(oForm.captcha.value)
						+ '&offset=' + encodeURIComponent(oForm.offset.value));
					mode = 3;
				}
				else {
					var oLink = document.getElementById('dllink');
					oLink.onclick = function () {
						return SaveDownload();
					}
					var oBtn = document.getElementById('dlbtn');
					oBtn.style.color = '#000000';
					oBtn.style.cursor = 'pointer';
					oBtn.onmouseover = function () {
						this.style.backgroundColor = '#FFFFFF';
					}
					oBtn.onmouseout = function () {
						this.style.backgroundColor = '#EEEEEE';
					}
					while (oBtn.firstChild)
						oBtn.removeChild(oBtn.firstChild);
					var oText = document.createTextNode('保存');
					oBtn.appendChild(oText);
					ShowMessage("ダウンロードが完了しました。\n"
						+ "[保存] をクリックしてファイルを保存してください。", false);
					mode = 8;
				}
			}
			else
				ShowMessage('通信エラーが発生しました。', true);
		}
		else {
			var pos = 0;
			var chr = [];
			while (pos < bin.length) {
				var cod = bin[pos];
				if (cod >= 0x80) {
					var len;
					if (cod < 0xC0)
						break;
					else if (cod < 0xE0) {
						cod &= 0x1F;
						len = 1;
					}
					else if (cod < 0xF0) {
						cod &= 0x0F;
						len = 2;
					}
					else
						break;
					if (pos + len >= bin.length)
						break;
					while (len > 0) {
						pos++;
						cod = (cod << 6) | (bin[pos] & 0x3F);
						len--;
					}
				}
				chr.push(cod);
				pos++;
			}
			var msg = String.fromCharCode.apply(null, chr);
			if (msg.charAt(0) == ' ') {
				msg = msg.substr(1);
				var trial = Number(oForm.trial.value);
				if (trial < 5) {
					trial++;
					oForm.trial.value = trial;
					setTimeout('RestartDownload()', 3000);
				}
			}
			ShowMessage(msg, true);
		}
	}
	else
		ShowMessage('通信エラーが発生しました。', true);
	SetActive(mode);
}
function SaveDownload()
{
	var oLink = document.getElementById('dllink');
	var name = oLink.getAttribute('download');
	if (name.match(/\.zip$/i))
		ValidateZipFile();
	var blob = new Blob([pool], {type:'application/octet-stream'});
	if (window.navigator.msSaveBlob) {
		window.navigator.msSaveBlob(blob, name);
		SetActive(0);
		CloseDownload(false);
		return false;
	}
	else {
		oLink.setAttribute('href', window.URL.createObjectURL(blob));
		SetActive(0);
		CloseDownload(false);
		return true;
	}
}
function ValidateZipFile()
{
	var data = new Uint8Array(pool);
	var total = data.length;
	var pos = total - 22;
	var off = pos > 256 ? 256 : pos;
	while (off > 0) {
		if (data[pos] == 0x50 && data[pos + 1] == 0x4B &&
			data[pos + 2] == 0x05 && data[pos + 3] == 0x06)
			break;
		pos--;
		off--;
	}
	if (off == 0)
		return;
	var nums = data[pos + 10] | (data[pos + 11] << 8);
	var size = data[pos + 12] | (data[pos + 13] << 8)
		| (data[pos + 14] << 16) | (data[pos + 15] << 24);
	pos = data[pos + 16] | (data[pos + 17] << 8)
		| (data[pos + 18] << 16) | (data[pos + 19] << 24);
	var limit = pos + size;
	if (limit > total)
		return;
	for (var i = 0; i < nums; i++) {
		if (pos + 46 > limit)
			break;
		if (data[pos] != 0x50 || data[pos + 1] != 0x4B ||
			data[pos + 2] != 0x01 || data[pos + 3] != 0x02)
			break;
		if (data[pos + 10] == 0) {
			off = data[pos + 42] | (data[pos + 43] << 8)
				| (data[pos + 44] << 16) | (data[pos + 45] << 24);
			ValidateZipEntry(data, off, pos + 16);
		}
		pos += (data[pos + 28] | (data[pos + 29] << 8))
			+ (data[pos + 30] | (data[pos + 31] << 8))
			+ (data[pos + 32] | (data[pos + 33] << 8)) + 46;
		if (pos >= limit)
			break;
	}
}
function ValidateZipEntry(data, pos, crcoff)
{
	var total = data.length;
	if (pos + 30 > total)
		return;
	if (data[pos + 8] != 0)
		return;
	var len = data[pos + 22] | (data[pos + 23] << 8)
		| (data[pos + 24] << 16) | (data[pos + 25] << 24);
	var off = data[pos + 18] | (data[pos + 19] << 8)
		| (data[pos + 20] << 16) | (data[pos + 21] << 24);
	if (len != off)
		return;
	off = (data[pos + 26] | (data[pos + 27] << 8))
		+ (data[pos + 28] | (data[pos + 29] << 8)) + pos + 30;
	if (off + len > total)
		return;
	var crc = CalculateCrc(data, off, len);
	data[pos + 14] = crc;
	data[pos + 15] = crc >>> 8;
	data[pos + 16] = crc >>> 16;
	data[pos + 17] = crc >>> 24;
	data[crcoff] = crc;
	data[crcoff + 1] = crc >>> 8;
	data[crcoff + 2] = crc >>> 16;
	data[crcoff + 3] = crc >>> 24;
}
function CalculateCrc(data, off, len)
{
	var crc;
	var map = new Uint32Array(256);
	for (var i = 0; i < 256; i++) {
		crc = i;
		for (var j = 0; j < 8; j++) {
			if (crc & 1)
				crc = 0xEDB88320 ^ (crc >>> 1);
			else
				crc = crc >>> 1;
		}
		map[i] = crc;
	}
	crc = 0xFFFFFFFF;
	while (len > 0) {
		crc = crc ^ data[off];
		crc = map[crc & 0xFF] ^ (crc >>> 8);
		off++;
		len--;
	}
	crc ^= 0xFFFFFFFF;
	return crc;
}
function ShowMessage(msg, error)
{
	var oDiv = document.getElementById('dlmsg');
	while (oDiv.firstChild)
		oDiv.removeChild(oDiv.firstChild);
	oDiv.style.color = error ? '#FF0000' : '#000000';
	var lines = msg.split('\n');
	for (var i = 0; i < lines.length; i++) {
		if (i > 0) {
			var oBreak = document.createElement('br');
			oDiv.appendChild(oBreak);
		}
		var oText = document.createTextNode(lines[i]);
		oDiv.appendChild(oText);
	}
}
function CheckActive(popup)
{
	var form = document.getElementById('settings');
	var active = form.active.value;
	if (active == 0)
		return true;
/*
	if (popup) {
		if (active == 1)
			alert('ダウンロードの準備中です。');
		if (active == 2)
			alert('画像認証データを取得中です。');
		if (active == 3)
			alert('ファイルのダウンロード中です。');
		if (active == 8)
			alert('ファイルが保存されていません。');
	}
*/
	return false;
}
function SetActive(mode)
{
	var oForm = document.getElementById('settings');
	oForm.active.value = mode;
}
function CheckAbort()
{
	var oForm = document.getElementById('settings');
	if (oForm.active.value != 9)
		return false;
	oForm.active.value = 0;
	return true;
}
function OpenDownload()
{
	var oDiv = document.getElementById('dlback');
	oDiv.style.display = 'block';
	var cx = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
	var cy = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
	var off = document.documentElement.scrollTop || document.body.scrollTop;
	var oBox = document.getElementById('dlbox');
	oBox.style.display = 'block';
	cx = (cx - 400) / 2;
	cy = (cy - 200) / 2 + off;
	if (cx < 0)
		cx = 0;
	if (cy < 0)
		cy = 0;
	oBox.style.left = cx + 'px';
	oBox.style.top = cy + 'px';
}
function CloseDownload(force)
{
	var oForm = document.getElementById('settings');
	var active = oForm.active.value;
	if (active != 0) {
		if (!force)
			return false;
		if (active < 5)
			oForm.active.value = 9;
		else
			oForm.active.value = 0;
	}
	var oBox = document.getElementById('dlbox');
	oBox.style.display = 'none';
	var oDiv = document.getElementById('dlback');
	oDiv.style.display = 'none';
	pool = null;
}
function FormatNumber(num)
{
	var str = num.toString();
	var len = str.length;
	if (len <= 3)
		return str;
	var pos = len % 3;
	if (pos == 0)
		pos = 3;
	var ret = str.substr(0, pos);
	while (pos < len) {
		ret += ',' + str.substr(pos, 3);
		pos += 3;
	}
	return ret;
}
function CreateHttpRequest()
{
	if ('XMLHttpRequest' in window)
		return new XMLHttpRequest();
	else if ('ActiveXObject' in window) {
		try {
			return new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (e) {
			try {
				return new ActiveXObject('Microsoft.XMLHTTP');
			}
			catch (e2) {
				return nul;
			}
		}
	}
	return null;
}
function RequestRetry()
{
	RequestFileInfo();
}
function RequestFileInfo()
{
	var req = CreateHttpRequest();
	if (req) {
		var list = '';
		for (var i = 0; i < flist.length; i++) {
			if (i > 0)
				list += ',';
			list += flist[i].name;
		}
		req.open('POST', '/cabinet/', true);
		req.onreadystatechange = function () {
			InsertFileInfo(req);
		}
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		req.send('sess=' + now.getTime() + '&info=' + encodeURIComponent(list));
	}
	else {
		HideLoading();
		ShowExtern();
	}
}
function InsertFileInfo(req)
{
	if (req.readyState != 4)
		return;
	if (req.status != 200) {
		rcnt++;
		if (rcnt <= 10)
			setTimeout('RequestRetry()', 3000);
		else {
			HideLoading();
			ShowExtern();
		}
		return;
	}
	if (req.responseText.charAt(0) != '[') {
		if (req.responseText.charAt(0) == 'c') {
			rcnt++;
			if (rcnt <= 10)
				setTimeout('RequestRetry()', 3000);
			else {
				HideLoading();
				ShowExtern();
			}
		}
		else {
			HideLoading();
			ShowExtern();
		}
		return;
	}
	HideLoading();
	var i;
	var aPars = document.getElementsByTagName('p');
	for (i = 0; i < aPars.length; i++) {
		var className = aPars[i].getAttribute('className')
			|| aPars[i].getAttribute('class');
		if (String(className).indexOf('delay') != -1)
			aPars[i].style.display = 'block';
	}
	var aInfo = eval('([' + req.responseText + '])');
	var done = false;
	var envok = CheckBrowser();
	if (flist.length == aInfo.length) {
		for (i = 0; i < flist.length; i++) {
			if (aInfo[i].length >= 3) {
				if (aInfo[i][0] >= 0 && !done) {
					ShowDownloadItem('h1');
					ShowDownloadItem('h2');
					ShowDownloadItem('h3');
					ShowDownloadItem('p');
					ShowDownloadItem('div');
					done = true;
				}
				if (aInfo[i][0] > 0 && envok)
					InsertSingleFileInfo(flist[i], aInfo[i]);
				else if (aInfo[i][0] == 0 || (aInfo[i][0] > 0 && !envok))
					InsertDummyFileInfo(flist[i], aInfo[i], envok);
			}
		}
	}
}
function InsertSingleFileInfo(file, info)
{
	if (info[0] == 2) {
		var oSp = document.createElement('img');
		oSp.setAttribute('src', '/dlman/sp.gif');
		oSp.setAttribute('alt', 'sp');
		oSp.setAttribute('width', '32px');
		oSp.setAttribute('height', '16px');
		file.div.insertBefore(oSp, file.link.nextSibling);
	}
	var mdt = new Date();
	var pass = mdt.getTime() - info[2] * 1000;
	var className = file.link.getAttribute('className')
		|| file.link.getAttribute('class');
	if (String(className).indexOf('old') != -1) {
		var oNew = document.createElement('img');
		oNew.setAttribute('src', '/dlman/old.gif');
		oNew.setAttribute('alt', 'old');
		oNew.setAttribute('width', '32px');
		oNew.setAttribute('height', '16px');
		file.div.insertBefore(oNew, file.link.nextSibling);
	}
	else if (pass < 2592000000) {
		var oNew = document.createElement('img');
		if (pass < 86400000) {
			oNew.setAttribute('src', '/dlman/new.gif');
			oNew.setAttribute('alt', 'new');
		}
		else if (pass < 604800000) {
			oNew.setAttribute('src', '/dlman/hot.gif');
			oNew.setAttribute('alt', 'hot');
		}
		else {
			oNew.setAttribute('src', '/dlman/cool.gif');
			oNew.setAttribute('alt', 'cool');
		}
		oNew.setAttribute('width', '32px');
		oNew.setAttribute('height', '16px');
		file.div.insertBefore(oNew, file.link.nextSibling);
	}
	mdt.setTime(info[2] * 1000);
	var oSpan = document.createElement('span');
	oSpan.style.fontSize = 'smaller';
	var oText = document.createTextNode(
		' (' + FormatNumber(info[1]) + 'バイト) - ' +
		mdt.getFullYear() + '/' +
		"0".concat(mdt.getMonth() + 1).slice(-2) + '/' +
		"0".concat(mdt.getDate()).slice(-2) + ' ' +
		"0".concat(mdt.getHours()).slice(-2) + ':' +
		"0".concat(mdt.getMinutes()).slice(-2) + ':' +
		"0".concat(mdt.getSeconds()).slice(-2));
	oSpan.appendChild(oText);
	file.div.insertBefore(oSpan, file.link.nextSibling);
	var oDl = document.createElement('img');
	oDl.setAttribute('src', '/dlman/dl.gif');
	oDl.setAttribute('alt', '');
	oDl.setAttribute('width', '20px');
	oDl.setAttribute('height', '16px');
	file.div.insertBefore(oDl, file.link);
	if (info.length >= 4) {
		file.link.setAttribute('id', info[3]);
		var oOldText = file.link.firstChild;
		var desc = oOldText.nodeValue;
		var re = RegExp("/" + desc + "(\\d)(\\d{2})(\\w+\\d)?\\.");
		if (info[3].match(re)) {
			desc = desc + " " + RegExp.$1 + "." + RegExp.$2 + RegExp.$3;
			var oNewText = document.createTextNode(desc);
			file.link.replaceChild(oNewText, oOldText);
		}
	}
	file.link.setAttribute('id', file.name + '/' + info[1]);
	file.link.onmouseover = function () {
		this.style.color = '#FF0000';
		this.style.textDecoration = 'underline';
	};
	file.link.onmouseout = function () {
		this.style.color = '#0000FF';
		this.style.textDecoration = 'none';
	};
	file.link.onclick = function () {
		Download(this.getAttribute('id'));
		return false;
	};
	var name = file.name.split(/\//);
	file.link.setAttribute('title', name[1] + ' のダウンロード');
	file.link.style.color = '#0000FF';
	file.link.style.cursor = 'pointer';
	file.div.style.display = 'block';
}
function InsertDummyFileInfo(file, info, envok)
{
	var oSpan = document.createElement('span');
	oSpan.style.fontSize = 'smaller';
	var desc;
	if (info[1] != 0 && info[2] != 0)
		desc = 'ダウンロードできません';
	else
		desc = '現在ダウンロードできません';
	var oText = document.createTextNode(' - ' + desc);
	oSpan.appendChild(oText);
	file.div.insertBefore(oSpan, file.link.nextSibling);
	var mdt = new Date();
	var pass = mdt.getTime() - info[2] * 1000;
	if (pass < 2592000000) {
		var oNew = document.createElement('img');
		if (pass < 86400000) {
			oNew.setAttribute('src', '/dlman/new.gif');
			oNew.setAttribute('alt', 'new');
		}
		else if (pass < 604800000) {
			oNew.setAttribute('src', '/dlman/hot.gif');
			oNew.setAttribute('alt', 'hot');
		}
		else {
			oNew.setAttribute('src', '/dlman/cool.gif');
			oNew.setAttribute('alt', 'cool');
		}
		oNew.setAttribute('width', '32px');
		oNew.setAttribute('height', '16px');
		file.div.insertBefore(oNew, file.link.nextSibling);
	}
	if (info[1] != 0 && info[2] != 0) {
		mdt.setTime(info[2] * 1000);
		var oSpan = document.createElement('span');
		oSpan.style.fontSize = 'smaller';
		var oText = document.createTextNode(
			' (' + FormatNumber(info[1]) + 'バイト) - ' +
			mdt.getFullYear() + '/' +
			'0'.concat(mdt.getMonth() + 1).slice(-2) + '/' +
			'0'.concat(mdt.getDate()).slice(-2) + ' ' +
			'0'.concat(mdt.getHours()).slice(-2) + ':' +
			'0'.concat(mdt.getMinutes()).slice(-2) + ':' +
			'0'.concat(mdt.getSeconds()).slice(-2));
		oSpan.appendChild(oText);
		file.div.insertBefore(oSpan, file.link.nextSibling);
		file.link.style.cursor = 'pointer';
		if (envok) {
			file.link.onclick = function () {
				alert('アクセス鍵が必要です。');
				return false;
			}
		}
		else {
			file.link.onclick = function () {
				alert('新しいブラウザが必要です。');
				return false;
			}
		}
	}
	var oDl = document.createElement('img');
	oDl.setAttribute('src', '/dlman/dl.gif');
	oDl.setAttribute('alt', '');
	oDl.setAttribute('width', '20px');
	oDl.setAttribute('height', '16px');
	file.div.insertBefore(oDl, file.link);
	if (info.length >= 4) {
		file.name = info[3];
		var oOldText = file.link.firstChild;
		var desc = oOldText.nodeValue;
		var re = RegExp("/" + desc + "(\\d)(\\d{2})\\.");
		if (info[3].match(re)) {
			desc = desc + " " + RegExp.$1 + "." + RegExp.$2;
			var oNewText = document.createTextNode(desc);
			file.link.replaceChild(oNewText, oOldText);
		}
	}
	file.link.setAttribute('id', file.name + '/' + info[1]);
	var name = file.name.split(/\//);
	file.link.setAttribute('title', name[1]);
	file.div.style.display = 'block';
}
function ShowDownloadItem(tag)
{
	var aItems = document.getElementsByTagName(tag);
	for (var i = 0; i < aItems.length; i++) {
		var className = aItems[i].getAttribute('className')
			|| aItems[i].getAttribute('class');
		if (String(className).indexOf('dlitem') != -1) {
			aItems[i].style.display = 'block';
		}
	}
}
function ShowLoading()
{
	for (var i = 0; i < llist.length; i++) {
		var oDiv = document.createElement('div');
		oDiv.setAttribute('id', 'loading');
		oDiv.style.textAlign = 'center';
		var oText = document.createTextNode('ダウンロード情報を取得しています… ');
		oDiv.appendChild(oText);
		var oImg = document.createElement('img');
		oImg.setAttribute('src', '/dlman/loading.gif');
		oImg.setAttribute('alt', 'loading');
		oImg.setAttribute('width', '24px');
		oImg.setAttribute('height', '24px');
		oImg.setAttribute('align', 'middle');
		oDiv.appendChild(oImg);
		llist[i].parentNode.insertBefore(oDiv, llist[i]);
		llist[i] = oDiv;
	}
}
function HideLoading()
{
	for (var i = 0; i < llist.length; i++)
		llist[i].parentNode.removeChild(llist[i]);
	llist.length = 0;
}
function ShowExtern()
{
	var aH2 = document.getElementsByTagName('h2');
	for (i = 0; i < aH2.length; i++) {
		var className = aH2[i].getAttribute('className')
			|| aH2[i].getAttribute('class');
		if (String(className).indexOf('extern') != -1)
			aH2[i].style.display = 'block';
	}
	var aPars = document.getElementsByTagName('p');
	for (i = 0; i < aPars.length; i++) {
		var className = aPars[i].getAttribute('className')
			|| aPars[i].getAttribute('class');
		if (String(className).indexOf('extern') != -1)
			aPars[i].style.display = 'block';
	}
}
function CreateSettings() {
	var oForm = document.createElement('form');
	oForm.setAttribute('id', 'settings');
	oForm.setAttribute('name', 'settings');
	var oInput = document.createElement('input');
	oInput.setAttribute('id', 'active');
	oInput.setAttribute('name', 'active');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('value', '0');
	oForm.appendChild(oInput);
	document.body.appendChild(oForm);
}
function SolidColor(rgb)
{
	var pat = new Uint8Array([
		0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x01, 0x00,
		0x01, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
		rgb >>> 16, rgb >>> 8, rgb,
		0x2C, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
		0x00, 0x00, 0x02, 0x02, 0x4C, 0x01, 0x00, 0x3B
		]);
	var blob = new Blob([pat], {type:'image/gif'});
	return window.URL.createObjectURL(blob);
}
function CreateDownloadBox() {
	var oBox = document.createElement('div');
	oBox.setAttribute('id', 'dlbox');
	oBox.style.display = 'none';
	var oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dltool');
	var oSpan = document.createElement('span');
	oSpan.setAttribute('id', 'dlclbtn');
	oSpan.onmouseover = function() {
		this.style.color = '#777777';
		this.style.backgroundColor = '#FFFFFF';
	}
	oSpan.onmouseout = function() {
		this.style.color = '#FFFFFF';
		this.style.backgroundColor = '#777777';
	}
	oSpan.onclick = function () {
		CloseDownload(true);
	}
	var oText = document.createTextNode("\u00D7");
	oSpan.appendChild(oText);
	oDiv.appendChild(oSpan);
	oBox.appendChild(oDiv);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlhead');
	oText = document.createTextNode('ファイルのダウンロード');
	oDiv.appendChild(oText);
	oBox.appendChild(oDiv);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlinfo');
	oBox.appendChild(oDiv);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlmsgph');
	var oSub = document.createElement('div');
	oSub.setAttribute('id', 'dlmsg');
	oDiv.appendChild(oSub);
	oBox.appendChild(oDiv);
	var oForm = document.createElement('form');
	oForm.setAttribute('id', 'dlform');
	var oInput = document.createElement('input');
	oInput.setAttribute('type', 'text');
	oInput.setAttribute('name', 'captcha');
	oInput.setAttribute('size', '10');
	oInput.setAttribute('maxlength', '6');
	oInput.style.paddingLeft = '4px';
	oForm.appendChild(oInput);
	oInput = document.createElement('input');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('name', 'ident');
	oForm.appendChild(oInput);
	oInput = document.createElement('input');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('name', 'trial');
	oForm.appendChild(oInput);
	oInput = document.createElement('input');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('name', 'sess');
	oForm.appendChild(oInput);
	oInput = document.createElement('input');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('name', 'length');
	oForm.appendChild(oInput);
	oInput = document.createElement('input');
	oInput.setAttribute('type', 'hidden');
	oInput.setAttribute('name', 'offset');
	oForm.appendChild(oInput);
	oText = document.createTextNode(' ');
	oForm.appendChild(oText);
	var oLink = document.createElement('a');
	oLink.setAttribute('id', 'dllink');
	oLink.setAttribute('href', '#');
	var oBtn = document.createElement('span');
	oBtn.setAttribute('id', 'dlbtn');
	oLink.appendChild(oBtn);
	oForm.appendChild(oLink);
	oBox.appendChild(oForm);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlcapph');
	var oImg = document.createElement('img');
	oImg.setAttribute('id', 'dlcapimg');
	oImg.setAttribute('width', 192);
	oImg.setAttribute('height', 32);
	oImg.setAttribute('src', SolidColor(0xCCCCCC));
	oDiv.appendChild(oImg);
	oBox.appendChild(oDiv);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlstaph');
	oSub = document.createElement('div');
	oSub.setAttribute('id', 'dlsta');
	oDiv.appendChild(oSub);
	oSub = document.createElement('div');
	oSub.setAttribute('id', 'dlprog');
	oImg = document.createElement('img');
	oImg.setAttribute('id', 'dlprogimg1');
	oImg.setAttribute('width', 0);
	oImg.setAttribute('height', 12);
	oImg.setAttribute('src', SolidColor(0x00CC00));
	oSub.appendChild(oImg);
	oImg = document.createElement('img');
	oImg.setAttribute('id', 'dlprogimg0');
	oImg.setAttribute('width', 200);
	oImg.setAttribute('height', 12);
	oImg.setAttribute('src', SolidColor(0x000000));
	oSub.appendChild(oImg);
	oDiv.appendChild(oSub);
	oBox.appendChild(oDiv);
	document.body.appendChild(oBox);
	oDiv = document.createElement('div');
	oDiv.setAttribute('id', 'dlback');
	oDiv.style.display = 'none';
	oDiv.onclick = function () {
		CloseDownload(false);
	}
	document.body.appendChild(oDiv);
}
function CreateStatusBar()
{
	var oBar = document.createElement('div');
	oBar.setAttribute('id', 'dlstabar');
	var oBtn = document.createElement('span');
	oBtn.setAttribute('id', 'dlstabtn');
	var oText = document.createTextNode("\u00D7");
	oBtn.appendChild(oText);
	oBtn.onclick = function () {
		this.parentNode.style.display = 'none';
	}
	oBar.appendChild(oBtn);
	oText = document.createTextNode('本ページはご使用のブラウザと互換がありません。');
	oBar.appendChild(oText);
	document.body.appendChild(oBar);
}
function CheckBrowser() {
	if ('XMLHttpRequest' in window && 'ArrayBuffer' in window && 'Blob' in window)
		return true;
	return false;
}
window.onload = function () {
	if (CheckBrowser()) {
		CreateDownloadBox();
		CreateSettings();
	}
	else
		CreateStatusBar();
	var aDivs = document.getElementsByTagName('div');
	var files = 0;
	var loads = 0;
	for (var i = 0; i < aDivs.length; i++) {
		var className = aDivs[i].getAttribute('className')
			|| aDivs[i].getAttribute('class');
		if (className == 'download') {
			var aSpans = aDivs[i].getElementsByTagName('span');
			for (var j = 0; j < aSpans.length; j++) {
				var className = aSpans[j].getAttribute('className')
					|| aSpans[j].getAttribute('class');
				if (String(className).indexOf('link') != -1) {
					var id = aSpans[j].getAttribute('id');
					flist[files] = new Object();
					flist[files].name = id;
					flist[files].div = aDivs[i];
					flist[files].link = aSpans[j];
					files++;
				}
			}
			llist[loads] = aDivs[i];
			loads++;
		}
	}
	if (files > 0) {
		ShowLoading();
		RequestFileInfo();
	}
}
